from PyQt4.QtGui import *
from PyQt4.QtCore import *
from processTable import *
from MainWindow import *
from schedulate import *
from sjf import *
from srtn import *
from fcfs import *
from lottery import *
from rr import *
from guranteed import *

def customEditor():
      return QSpinBox()
  
class Ui(Ui_MainWindow):
  """manipulated user interface"""
  def __init__(self, parent):
    self.parent = parent
    self.setup()

  def addProcess(self):
    self.tm.insertRow(1)
    self.resetButton.setEnabled(True)
    
  def setAlgorithm(self, index):
    self.algorithm = [SJF, FCFS, SRTN, Lottery, RR, Guranteed][index]
    try:
      self.algorithm.needTS
      self.ts.setEnabled(True)
      self.tsLabel.setEnabled(True)
    except:
      self.ts.setEnabled(False)
      self.tsLabel.setEnabled(False)


  def setup(self):
    """setup user interface"""
    self.MainWindow = QMainWindow()
    self.setupUi(self.MainWindow)
    self.resultBox.hide()
    
    self.tm = ProcessTableModel()    
    self.tv.setModel(self.tm)
    self.tv.setItemDelegate(ProcessTableDelegate())
    self.tv.setColumnWidth(1, 75)
    self.tv.setColumnWidth(2, 70)
    
    self.setAlgorithm(self.algorithmsBox.currentIndex())

    QObject.connect(self.addProcessButton, SIGNAL("clicked()"), self.addProcess)
    QObject.connect(self.simulateButton, SIGNAL("clicked()"), self.simulate)
    QObject.connect(self.algorithmsBox, SIGNAL("currentChanged(int)"), self.setAlgorithm)
    QObject.connect(self.backButton, SIGNAL("clicked()"), self.backTable)
    QObject.connect(self.resetButton, SIGNAL("clicked()"), self.resetTable)
    

  def backTable(self):
    self.tm.unschedule()
    self.backButton.setEnabled(False)


  def resetTable(self):
    del self.tm
    self.tm = ProcessTableModel()
    self.tv.setModel(self.tm)
    self.tv.setColumnWidth(1, 75)
    self.tv.setColumnWidth(2, 70)
    self.resetButton.setEnabled(False)
    self.backButton.setEnabled(False)
    
    
  def simulate(self):
    s = self.algorithm(self.tm.items())
    try:
      self.algorithm.needTS
      r = s.solve(self.ts.value())
    except:
      r = s.solve()
      
    self.tm.schedule(r)

    self.avgResponse.setText(str(s.response))
    self.avgWaiting.setText(str(s.waiting))
    self.avgTurnaround.setText(str(s.turnaround))
    
    self.backButton.setEnabled(True)
    self.resetButton.setEnabled(True)
    self.resultBox.show()
    
  def show(self):
    """show main window widget"""
    self.MainWindow.show()
