"""Process Module"""

class Process(object):
  def __init__(self, name="Unnamed", start=0, duration=1):
    self.__name = name
    self.__realStart = self.__start = start
    self.__duration = duration or 1
    self.__progress = 0

  def advance(self, elapsed=None):
    if elapsed is None:
      self.__progress = 100
    else:
      self.__progress += elapsed*100/self.__duration
      if self.__progress > 100:
	self.__progress = 100
    return self
    
    
  def name(self, name=None):
    if name is None:
      return self.__name
    self.__name = name
    return self


  def start(self, start=None):
    if start is None:
      return self.__start
    self.__realStart = self.__start = start
    return self


  def duration(self, duration=None):
    if duration is None:
      return self.__duration
    self.__duration = duration
    return self


  def progress(self, progress=None):
    if progress is None:
      return self.__progress
    self.__progress = progress
    return self

  def remaining(self):
    return self.__duration - self.__progress * self.__duration / 100

  def realStart(self):
    return self.__realStart
    
    
  def restart(self, start):
    self.__start = start
    
    
  def waiting(self):
    return self.__start - self.__realStart
    
    
  def __str__(self):
    return "{0} start at {1} with {2} duration {3}% completed".format(self.name(), self.start(), self.duration(), self.progress())


  @staticmethod
  def __durcmp__(f, s):
    if f.duration() < s.duration():
      return -1
    elif f.duration() == s.duration():
      return 0
    else:
      return 1


  @staticmethod
  def __strcmp__(f, s):
    if f.start() < s.start():
      return -1
    elif f.start() == s.start():
      return 0
    else:
      return 1
      
  @staticmethod
  def __rmncmp__(f, s):
    if f.remaining() < s.remaining():
      return -1
    elif f.remaining() == s.remaining():
      return 0
    else:
      return 1   
      
if __name__=="__main__":
  first = Process("first job", 4, 3)
  second = Process("second job", 2,4)
  third = Process("third job", 6,2)
  
  first.start(8)
  db = [first, second, third]  
  db.sort(Process.__rstcmp__)
  
  for i in db:
    print i