from process import *
from schedule import *

class RR(Schedule):
  """Round Robin Scheduling implementation"""
  
  needTS = True
    
  def solve(self, ts):
    self._prcs.sort(Process.__strcmp__)
    count = len(self._prcs)
    result = []
    
    while len(self._prcs):
      p = self._prcs.pop(0)
	
      end = p.start() + min (ts, p.remaining())
      
      if not p.progress(): #first time running this job
	self.response += end - p.realStart()
	
      p.advance(ts)
      result.append(p)
      print p
      
      i=0
      while (i < len(self._prcs)):
	if self._prcs[i].start() <= end:
	  self._prcs[i].restart(end)
	else:
	    break
	i+=1
	
      if (p.progress() == 100):
	self.turnaround += end - p.realStart()
	self.waiting += p.waiting()
      else:
	p.restart(end)
	self._prcs.insert(i,p)

    self.waiting /= count
    self.turnaround /= count
    self.response /= count
    
    return result